/**
 * AUTO_GENERATED Do not change this file directly, use config.ts file instead
 *
 * @version 5
 */
import axios from "axios";
import { getAxiosInstance } from "./config";
/**
 * Cancellation handled here, you can cancel request by call promise.cancel()
 *
 * @example
 *   const promise = getUsers();
 *   setTimeout(() => promise.cancel(), 30000);
 *   const { data } = await promise;
 *
 * @param getPromise
 * @returns
 */
function cancellation(getPromise) {
    const source = axios.CancelToken.source();
    const promise = getPromise(source.token);
    //@ts-ignore
    promise.cancel = () => {
        source.cancel("request canceled");
    };
    return promise;
}
export const Http = {
    getRequest(url, queryParams, 
    //@ts-ignore
    _requestBody, security, configOverride) {
        return cancellation((cancelToken) => getAxiosInstance(security).get(url, {
            cancelToken,
            params: queryParams,
            ...configOverride,
        }));
    },
    postRequest(url, queryParams, requestBody, security, configOverride) {
        return cancellation((cancelToken) => getAxiosInstance(security).post(url, requestBody, {
            cancelToken,
            params: queryParams,
            ...configOverride,
        }));
    },
    putRequest(url, queryParams, requestBody, security, configOverride) {
        return cancellation((cancelToken) => getAxiosInstance(security).put(url, requestBody, {
            cancelToken,
            params: queryParams,
            ...configOverride,
        }));
    },
    patchRequest(url, queryParams, requestBody, security, configOverride) {
        return cancellation((cancelToken) => getAxiosInstance(security).patch(url, requestBody, {
            cancelToken,
            params: queryParams,
            ...configOverride,
        }));
    },
    deleteRequest(url, queryParams, requestBody, security, configOverride) {
        return cancellation((cancelToken) => getAxiosInstance(security).delete(url, {
            data: requestBody,
            cancelToken,
            params: queryParams,
            ...configOverride,
        }));
    },
};
